--[[ boniRob 

Author: 		HoFFi (modding-welt.com)
Remarks:		


Description: 	script for BoniRob

Version: 		1.0.0.0

Changelog: 		2020-10-22 	- initial release


--------------------------------------------------------------------------------------------------


]]


boniRob = {};

boniRob.modDir = g_currentModDirectory;
boniRob.currentModName = g_currentModName;

function boniRob.prerequisitesPresent(specializations)
    return true; 
end;


function boniRob.registerOverwrittenFunctions(vehicleType)
	--SpecializationUtil.registerOverwrittenFunction(vehicleType, "getCanAIImplementContinueWork", boniRob.getCanAIImplementContinueWork) 
	--Attachable.getIsImplementChainLowered = Utils.overwrittenFunction(Attachable.getIsImplementChainLowered, boniRob.getIsImplementChainLowered);
end



-- function boniRob:getCanAIImplementContinueWork(superFunc) 
	-- local spec = self.spec_attachable 
	-- local isReady = true 
	-- if spec.lowerAnimation ~= nil then 
		-- local time = self:getAnimationTime(spec.lowerAnimation) 
		-- isReady = time == 1 or time == 0 
	-- end 
	
	-- if spec.attacherVehicle ~= nil then 
		-- local jointDesc = spec.attacherVehicle:getAttacherJointDescFromObject(self) 
		-- if jointDesc.allowsLowering and self:getAINeedsLowering() then 
			-- if jointDesc.moveDown then 
				-- isReady = (jointDesc.moveAlpha == jointDesc.lowerAlpha or jointDesc.moveAlpha == jointDesc.upperAlpha) and isReady 
			-- end 
		-- end 
	-- end 
	-- return isReady 
-- end

function boniRob.registerEventListeners(vehicleType)
	for _, spec in pairs({"onLoad", "onUpdate", "onDraw"}) do
		SpecializationUtil.registerEventListener(vehicleType, spec, boniRob)
	end
end


function boniRob:onLoad(savegame)
	self.boniRob = {}
	self.boniRob.showInHud = Utils.getNoNil(getXMLBool(self.xmlFile, "vehicle.boniRob#showInHud"), true);
	self.boniRob.leftWheel = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.boniRob#leftWheel"), self.i3dMappings);
	self.boniRob.rightWheel = I3DUtil.indexToObject(self.components, getXMLString(self.xmlFile, "vehicle.boniRob#rightWheel"), self.i3dMappings);
	self.boniRob.warnSound = Utils.getNoNil(getXMLString(self.xmlFile, "vehicle.boniRob#warnSoundFile"), "$data/sounds/vehicles/reverse_beep/komatsu_reverse_beep_loop.ogg")
	self.boniRob.batteryCapacityHours = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.boniRob#batteryTime"), 0.25) * 3600000;
	self.boniRob.gaugeWidth = 0;
	self.boniRob.batteryCharge = 100;
	self.boniRob.timer = 0
	self.boniRob.dieselFillUnitI = Utils.getNoNil(getXMLInt(self.xmlFile, "vehicle.solarBatteryScript#dieselFillUnitIndex"), 1);
	self:setFillUnitCapacity(1, self.boniRob.batteryCapacityHours)
	self:addFillUnitFillLevel(self:getOwnerFarmId(), 1, self.boniRob.batteryCapacityHours, FillType.DIESEL, ToolType.UNDEFINED, nil)
	
	local fillUnit = self:getFillUnitByIndex(self.boniRob.dieselFillUnitI)
	fillUnit.updateMass = false
	
	self.turnOnAnimation1 = getXMLString(self.xmlFile, "vehicle.boniRob#anim")
end;

function boniRob:getIsImplementChainLowered(defaultIsLowered)
	if self.spec_turnOnVehicle ~= nil then
		if self:getIsTurnedOn() then
			return true 
		else
			return false 
		end
	else
		return false 
	end
end

function boniRob:doCheckSpeedLimit()
	if self.spec_turnOnVehicle ~= nil then
		if self:getIsTurnedOn() then
			return true 
		else
			return false 
		end
	else
		return false 
	end
end

function boniRob:onUpdate(dt)
	--self:setFillUnitCapacity(1, self.boniRob.batteryCapacityHours)
	--self:addFillUnitFillLevel(self:getOwnerFarmId(), 1, self.boniRob.batteryCapacityHours, FillType.DIESEL, ToolType.UNDEFINED, nil)

	if self.boniRob.leftWheel ~= nil and self.boniRob.rightWheel ~= nil then
		local x,_,_ = localToLocal(self.boniRob.rightWheel, self.boniRob.leftWheel, 0,0,0)
		self.boniRob.gaugeWidth = x
	end
	
	if g_currentMission.environment.isSunOn == false or g_currentMission.environment.weather:getIsRaining() then
			self.boniRob.timer = self.boniRob.timer + (1 * g_currentMission.missionInfo.timeScale);
			if self.boniRob.batteryCapacityHours <= 0 then
				self.boniRob.batteryCapacityHours = 0 
			else
				self.boniRob.batteryCapacityHours = self.boniRob.batteryCapacityHours - (10 * g_currentMission.missionInfo.timeScale)
				self:addFillUnitFillLevel(self:getOwnerFarmId(), 1, -(10 * g_currentMission.missionInfo.timeScale), FillType.DIESEL, ToolType.UNDEFINED, nil)
			end
	else
		self.boniRob.timer = 0
		if self.boniRob.batteryCapacityHours >= Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.boniRob#batteryTime"), 0.25) * 3600000 then
			self.boniRob.batteryCapacityHours = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.boniRob#batteryTime"), 0.25) * 3600000
		else
			self.boniRob.batteryCapacityHours = self.boniRob.batteryCapacityHours + (50 * g_currentMission.missionInfo.timeScale)
			self:addFillUnitFillLevel(self:getOwnerFarmId(), 1, (50 * g_currentMission.missionInfo.timeScale), FillType.DIESEL, ToolType.UNDEFINED, nil)
		end
	end
	
	if self.boniRob.timer == (1 * g_currentMission.missionInfo.timeScale) then
		g_currentMission:showBlinkingWarning(g_i18n:getText("noSolarMsg"), 4000)
	end
	
	if self.boniRob.batteryCapacityHours <= 120 and self.boniRob.batteryCapacityHours > 0 then
		local fileName = Utils.getFilename(self.boniRob.warnSound, self.baseDirectory)
		self.boniRob.warnSample = createSample("warnSampleSound")
		loadSample(self.boniRob.warnSample, fileName, false)
		playSample(self.boniRob.warnSample, 1, 1.0, 0, 0, 0)
		g_currentMission:showBlinkingWarning(g_i18n:getText("batteryEmtpy"), 4000)
	end
	
	self.boniRob.batteryCharge = (self.boniRob.batteryCapacityHours / (Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.boniRob#batteryTime"), 0.25) * 3600000)) * 100
	
	if self.spec_turnOnVehicle ~= nil then
		if self:getIsTurnedOn() then
			self:playAnimation(self.turnOnAnimation1, 2, self:getAnimationTime(self.turnOnAnimation1), true)
		else
			--self:updateAnimationByName("SprayWeederAnim", 9999999)
			self:stopAnimation(self.turnOnAnimation1, true)
		end
	end
end;

--Attachable.getIsImplementChainLowered = Utils.overwrittenFunction(Attachable.getIsImplementChainLowered, boniRob.getIsImplementChainLowered);
--Weeder.doCheckSpeedLimit = Utils.overwrittenFunction(Weeder.doCheckSpeedLimit, boniRob.doCheckSpeedLimit);

function boniRob:onDraw(isActiveForInput, isSelected)
	if self.isClient then
		if isSelected then
			if self.boniRob.showInHud then
				text1 = (MathUtil.round(self.boniRob.gaugeWidth, 1) * -1) - 0.1
				g_currentMission:addExtraPrintText(g_i18n:getText("trackGauge") .. ": " .. text1 .. "m     " .. g_i18n:getText("battery") .. ": " .. MathUtil.round(self.boniRob.batteryCharge) .. "%/" .. tostring(MathUtil.round(((self.boniRob.batteryCapacityHours / 60000) / g_currentMission.missionInfo.timeScale), 2)) .. "min" )
				-- timers for testing
				--g_currentMission:addExtraPrintText(tostring(self.boniRob.timer) .. "     " .. tostring(self.boniRob.batteryCapacityHours))
			end
		end
	end
end